<template>
    <div class="message-list">
        <span class="float-right">
            <button
                class="btn btn-outline-info btn-sm m-2"
                @click="clear()"
            >clear</button>
        </span>
        <h2 class="message-list__title">Message list</h2>

        <div class="material-pagination">
            <div>Messages per page</div>

            <div>
                <select v-model="perPage" class="material-pagination__selector">
                    <option v-for="option in perPageOption" :value="option" :key="option">{{option}}</option>
                </select>
            </div>

            <div>{{offset}} - {{limit}} of {{messages.length}}</div>

            <div>
                <button @click="page = 1" class="btn btn-link" :disabled="isFirstPage"><<</button>
                <button @click="prev" class="btn btn-link" :disabled="isFirstPage"><</button>
                <button @click="next" class="btn btn-link" :disabled="isLastPage">></button>
                <button @click="page = totalPage" class="btn btn-link" :disabled="isLastPage">>></button>
            </div>
        </div>

        <transition-group
            name="message"
            tag="ul"
            class="message-list__wrapper"
            mode="out-in"
        >
            <li
                class="message"
                v-for="(message, index) in paginatedData"
                :key="message.id"
            >
                <span class="message__index">#{{index + offset}}</span>
                <span class="message__from">{{message.body.from}}</span>
                <span class="message__time">{{formatDate(message.timestamp)}}</span>
                <span class="message__body">{{message.body.content}}</span>
            </li>
        </transition-group>
    </div>
</template>
<style lang="scss">
    $transition: all 0.5s ease;

    .message-enter-active, .message-leave-active {
        transition: $transition;
    }
    .message-enter, .message-leave-to /* .fade-leave-active below version 2.1.8 */ {
        transition: $transition;
        opacity: 0;
    }

    .message-move {
        transition: transform 1s;
    }

    .material-pagination {
        display: flex;
        flex-wrap: wrap;
        justify-content: space-evenly;
        align-items: center;

        &__selector {
            border: none;
            outline: none;
            color: grey;
        }
    }

    .message-list {
        width: 60vw;
        box-shadow: 0 1px 3px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.24);
        transition: all 0.3s cubic-bezier(.25, .8, .25, 1);

        &__title {
            margin: 0;
            padding: 5px 0;
            text-align: center;
            box-shadow: 0 2px 2px -2px rgba(0, 0, 0, .2);
        }

        &__wrapper {
            max-height: 60vh;
            overflow-y: auto;
            padding: 0;
            list-style: none;

        }
    }

    .message {
        font-size: 10px;
        color: grey;
        font-weight: lighter;
        text-align: left;
        transition: $transition;
        background: white;
        padding: 10px;
        margin: 10px;
        box-shadow: 0 1px 3px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.24);
        box-sizing: border-box;

        &__time {
            padding-left: 15px;
        }

        &__from {
            text-align: right;
        }

        &__body {
            display: block;
            font-size: 15px;
            color: black;
            font-weight: bold;
        }
    }
</style>
<script>
    export default {
        name: 'MessageList',
        props: {
            initial: {}
        },
        data: () => ({
            messages: [],
            page: 1,
            perPage: 15,
            perPageOption: [
                15, 30, 50, 100
            ]
        }),
        computed: {
            offset () {
                return this.isFirstPage ? 1 : ((this.page * this.perPage) - this.perPage) + 1
            },
            limit () {
                const limit = this.offset + this.perPage - 1

                return limit <= this.messages.length
                    ? limit
                    : this.messages.length
            },
            paginatedData () {
                return this.messages.slice(this.offset, this.limit)
            },
            totalPage () {
                return Math.ceil(this.messages.length / this.perPage)
            },
            isFirstPage () {
                return this.page === 1
            },
            isLastPage () {
                return this.page === this.totalPage
            }
        },
        created () {
            console.log('initial message count', this.initial.length)
            this.messages = this.initial
            this.setupStream()
        },
        methods: {
            next () {
                if (!this.isLastPage) {
                    this.page += 1
                }
            },
            prev () {
                if (!this.isFirstPage) {
                    this.page -= 1
                }
            },
            formatDate (timestamp) {
                return new Date(timestamp * 1000)
            },
            async clear () {
                const {data} = await window.axios.delete('/messages/clear')

                if (data.success === true) {
                    this.messages = []
                }
            },
            setupStream () {
                const domain = location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : '')
                const es = new EventSource('/stream')

                es.addEventListener('message', event => {
                    if (event.origin !== domain) {
                        alert('Origin was not http://example.com')
                        return
                    }
                    const decoded = JSON.parse(event.data)

                    if (decoded.length !== this.messages.length) {
                        console.log('new messages available', decoded.length)

                        this.messages = decoded
                    }

                }, false)

                es.addEventListener('error', event => {
                    if (event.readyState === EventSource.CLOSED) {
                        console.log('Event was closed')
                        console.log(EventSource)
                    }
                }, false)
            }
        }
    }
</script>
